-- name: XMario
-- description: MARIO TO THE X

function x_pressed(m)

if m.action == ACT_GROUND_POUND_LAND then return end
if m.action == ACT_LONG_JUMP then return end
if m.action == ACT_WATER_IDLE then return end
if m.action == ACT_FLUTTER_KICK then return end
if m.action == ACT_BREASTSTROKE then return end
if m.action == ACT_WATER_ACTION_END then return end
if m.action == ACT_SWIMMING_END then return end
if m.action == ACT_WATER_PLUNGE then return end
if m.action == ACT_WATER_PUNCH then return end
if m.action == ACT_TWIRL_LAND then return end
if m.playerIndex ~= 0 then return end
if m.character.type ~= CT_MARIO then return end
  if m.controller.buttonPressed & X_BUTTON ~= 0 then
      if x_press_counter > 0 then
          set_jumping_action(m, ACT_TWIRLING, 0)
          x_press_counter = x_press_counter - 1
          set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, false)
          m.vel.y = m.forwardVel + 3
          m.faceAngle.y = m.intendedYaw
         end
  end

  if (m.action & ACT_FLAG_AIR) == 0 then
      x_press_counter = 1
  end

 if m.action == ACT_WALL_KICK_AIR then
      x_press_counter = 1
  end
end

hook_event(HOOK_MARIO_UPDATE, x_pressed)

function z_down(m)
if m.action == ACT_LONG_JUMP then return end
if m.action == ACT_WALK then return end
if m.playerIndex ~= 0 then return end
if m.character.type ~= CT_MARIO then return end
if m.input & INPUT_Z_DOWN ~= 0 then
if z_press_counter > 0 and m.action == ACT_GROUND_POUND_LAND then
          set_jumping_action(m, ACT_LONG_JUMP, 0)
          z_press_counter = z_press_counter - 1
          m.vel.y = 30.0
          m.forwardVel = m.forwardVel + 35
      end
      end

if (m.action & ACT_FLAG_AIR) == 0 then
      z_press_counter = 1
  end
end

hook_event(HOOK_MARIO_UPDATE, z_down)

function mario_update(m)

if m.action == ACT_TWIRLING and m.controller.buttonPressed & X_BUTTON ~= 0 then 
set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, false)
 end

if m.action == ACT_TWIRL_LAND then 
set_mario_action(m, ACT_WALKING, 0)
 end

if m.action == ACT_TWIRLING then 
m.particleFlags = PARTICLE_SPARKLES
end

if m.action == ACT_TWIRLING and m.input & INPUT_Z_DOWN ~= 0 then
         set_jumping_action(m,ACT_FREEFALL, 0)
         end

if m.controller.buttonPressed & B_BUTTON ~= 0 and m.action == ACT_LONG_JUMP then
set_jumping_action(m, ACT_DIVE, 0)
m.vel.y = 10.0
end

if m.controller.buttonDown & A_BUTTON ~= 0 and m.action == ACT_TWIRLING then
m.vel.y = 0.01
m.forwardVel = m.forwardVel + 1
end

if m.action == ACT_LONG_JUMP then return end
if m.action == ACT_WALK then return end
if m.playerIndex ~= 0 then return end
if m.character.type ~= CT_MARIO then return end
if m.controller.buttonDown & B_BUTTON ~= 0 then
if b_press_counter > 0 and m.action == ACT_TWIRLING then
          b_press_counter = b_press_counter - 1
          m.vel.y = m.vel.y - 50.0
      end
      end

if (m.action & ACT_FLAG_AIR) == 0 then
      b_press_counter = 999
  end

if m.action == ACT_WALKING and m.forwardVel > 31 then
m.forwardVel = m.forwardVel
end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function a_pressed(m)
if m.action == ACT_LONG_JUMP then return end
if m.action == ACT_WALK then return end
if m.playerIndex ~= 0 then return end
if m.character.type ~= CT_MARIO then return end
if m.input & INPUT_A_DOWN ~= 0 then
if a_press_counter > 0 and m.action == ACT_GROUND_POUND then
          set_jumping_action(m, FREEFALL, 0)
          a_press_counter = a_press_counter - 1
          m.vel.y = 30.0
          m.forwardVel = m.forwardVel + 35
      end
      end

if (m.action & ACT_FLAG_AIR) == 0 then
      z_press_counter = 1
  end
end

hook_event(HOOK_MARIO_UPDATE, z_down)
 
function x_pressed(m)

if m.action == ACT_GROUND_POUND_LAND then return end
if m.action == ACT_WATER_IDLE then return end
if m.action == ACT_FLUTTER_KICK then return end
if m.action == ACT_BREASTSTROKE then return end
if m.action == ACT_WATER_ACTION_END then return end
if m.action == ACT_SWIMMING_END then return end
if m.action == ACT_WATER_PLUNGE then return end
if m.action == ACT_WATER_PUNCH then return end
if m.action == ACT_TWIRL_LAND then return end
if m.playerIndex ~= 0 then return end
if m.character.type ~= CT_MARIO then return end
  if m.controller.buttonPressed & X_BUTTON ~= 0 and m.action == ACT_GROUND_POUND then
      if x_press_counter > 0 then
          set_jumping_action(m, ACT_TWIRLING, 0)
          x_press_counter = x_press_counter - 1
          set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, false)
          m.vel.y = 40.0
          m.forwardVel = 32
      end
  end

  if (m.action & ACT_FLAG_AIR) == 0 then
      x_press_counter = 1
  end

 if m.action == ACT_WALL_KICK_AIR then
      x_press_counter = 1
  end
end

hook_event(HOOK_MARIO_UPDATE, x_pressed)